function ModalPop() {
	var _this = this;
	var Selector = {};
	var isVidPlaying = false;
	var isVidEnded = false;
	var isAudPlaying = false;
	_this.start = function (_obj) {
		Selector = {			
			XML_NODE: null,
			CLASS_NAME: 'modal-pop',
			CONTAINER: '#global-modal-pop',
			VIEW_FILE: '',
			SHOW_ANIMATION: true,
			FONT_ICON_CLASS_OBJ: {				
				plus: 'icon-plus',
				minus: 'icon-minus'
			},
			ON_OK: null,
			ON_CLOSE: null,
			ALLOW_BG_CLICK_CLOSE: false,
			isLoaded: false
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.getClassName = function(){
		return Selector.CLASS_NAME;
	}
	_this.closeModal = function(){
		processModal(true);
	}
	function initTemplate() {
		Selector.isLoaded = false;
		//-- for multi tutorial pop	
		var tuExtraClass="";	
		if(Selector.CLASS_NAME == 'tutorial-pop'){
			var popXmlObj = APP.globalXmlsObj.globalXML.tutorialPop;
			if(popXmlObj){
				if(popXmlObj[APP.navData.topicId]){
					Selector.XML_NODE = popXmlObj[APP.navData.topicId];
					tuExtraClass = 'tutorial-pop_'+APP.navData.topicId;
				}else{
					Selector.XML_NODE = popXmlObj[0];
					tuExtraClass = 'tutorial-pop_0'
				}
			}else{

			}
		}
		//--
		if(Selector.XML_NODE == null){
			console.warn('XML NOT FOUND...')
			return;
		}
		if(APP.globalMessageOpen){return false;}
		APP.preloaderObj.show();
		$(Selector.CONTAINER).addClass(Selector.CLASS_NAME).addClass(tuExtraClass);
		if(Selector.VIEW_FILE != null && Selector.VIEW_FILE !== ''){
			//load html view
			$(Selector.CONTAINER).load(Selector.VIEW_FILE, function (responseTxt, statusTxt, xhr) {
				if (statusTxt == "success") {
					applyAniObj();
					$(document).trigger(APP.eventObj.ON_MODAL_HTML_LOAD);
					loadComplete();					
				}
				if (statusTxt == "error") {
					alert("An error occured: " + xhr.status + ": " + xhr.statusText+" : "+Selector.VIEW_FILE);					
				}
			});
			
		}else{
			$(Selector.CONTAINER).html(getAlertWinHtml());		
			applyData();	
		}
			
		
	}
	function getAlertWinHtml(){
		var str="";
		str+='<div class="modal-box">';
			str+='<div class="modal-alert">';
				str+='<div class="modal-titlebar">';
						
				str+='</div>';
				str+='<div class="modal-content-box">';
					
				str+='</div>';
				str+='<div class="modal-btnpane">';
					str+='<div class="modal-btn"></div>';
				str+='</div>';
			str+='</div>';
		str+='</div>';
		return str;
	}
	function applyData(){
		var textObj = Selector.XML_NODE;
		var str ='';
		applyAniObj();
		if(textObj.headerBar){
			var headerObj = textObj.headerBar[0];
			if(headerObj.closeBtn){
				var _obj = headerObj.closeBtn[0];
				var _className = _obj.className || '';
				var _style = _obj.style || '';
				var _txt = _obj.Text;
				str += '<a class=" btn modal-btn '+_className+' close-modal-btn" style ="'+_style+'" href="javascript:void(0);" >';
					str +='<span class="btn-icon font-icon icon-cross display-cell v-center">'+_txt+'</span>';
				str+='</a>';
			}
			if(headerObj.title){
				var _obj = headerObj.title[0];
				var _className = _obj.className || '';
				var _style = _obj.style || '';
				var _txt = _obj.Text;
				str+='<span class="modal-title '+_className+'" style="'+_style+'">'+_txt+'</span>';	
			}
			if(headerObj.text){
				var _obj = headerObj.text[0];
				var _className = _obj.className || '';
				var _style = _obj.style || '';
				var _txt = _obj.Text;
				str+='<span class="modal-title-txt '+_className+'" style="'+_style+'">'+_txt+'</span>';	
			}
			
			$(Selector.CONTAINER).find('.modal-titlebar').html(str);
		}else{
			$(Selector.CONTAINER).find('.modal-titlebar').remove();
		}
		str ='';
		if(textObj.ostPanel){
			var ostObj = textObj.ostPanel[0];
			var _className = ostObj.className || '';
			var _style = ostObj.style || '';
			str+='<div class="scroll-parent"><div class="scrollable">';
				str+='<div class="parent-box">';
				if(ostObj.text){
						str+='<div class="content-panel '+_className+'" style="'+_style+'">';
							str += APP.getHtmlStructObj.textPanelStruct(ostObj);					
						str+='</div>';				
				}
				//--for extra panel
				if(ostObj.extraPanel){
					var _eclassName = ostObj.extraPanel[0].className || '';
					var _estyle = ostObj.extraPanel[0].style || '';
					str+='<div class="extra-panel '+_eclassName+'" style="'+_estyle+'">';
					if(ostObj.extraPanel[0].text){
						str += APP.getHtmlStructObj.textPanelStruct(ostObj.extraPanel[0]);	
					}				
					str+='</div>';				
				}
				//--
				
				str+='</div>';
				
				str+='</div></div>';	
			//--
			$(Selector.CONTAINER).find('.modal-content-box').html(str);
			//--for progressbar
			var prEl = $('.help-progress.circle-progress-bar');
			APP.progressBarObj.createHtml(prEl);
			APP.progressBarObj.rotationUpdate(50, 180, prEl);
			//--
		}else{
			$(Selector.CONTAINER).find('.modal-content-box').remove();
		}
		str ='';
		if(textObj.bottomBar){
			var btmObj = textObj.bottomBar[0];
			if(btmObj.buttonTag){
				for(var i=0; i<btmObj.buttonTag.length; i++){
					var btnTagObj = btmObj.buttonTag[i];
					var _class = btnTagObj.className || '';
					var _style = btnTagObj.style || '';
					
					str += '<div class="btn-panel"><a class=" btn modal-btn with-radius '+_class+' " style ="'+_style+'" href="javascript:void(0);" data-id="'+i+'">';
					
					var iconObj = btnTagObj.btnIcon;
					if(iconObj){
						var _class = iconObj[0].className || '';
						var _style = iconObj[0].style || '';
						var _txt = iconObj[0].Text || '';					
						str += '<span class="btn-icon display-cell v-center '+_class+' " style ="'+_style+'">'+_txt+'</span>';
					}	
					var btnTextObj = btnTagObj.btnText;
					if(btnTextObj){
						var _class = btnTextObj[0].className || '';
						var _style = btnTextObj[0].style || '';
						var _txt = btnTextObj[0].Text || '';					
						str += '<span class="btn-txt display-cell v-center">'+_txt+'</span>';
					}
					str += '</a></div>';
				}				
			}
			$(Selector.CONTAINER).find('.modal-btnpane').html(str);
		}else{
			$(Selector.CONTAINER).find('.modal-btnpane').remove();
		}		
		loadComplete();		
	}
	function applyAniObj(){
		//--apply animation data
		var textObj = Selector.XML_NODE;
		if(textObj.dataAnimateType && textObj.dataAnimateType != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-type', textObj.dataAnimateType);
		}
		if(textObj.dataAnimateStartVal && textObj.dataAnimateStartVal != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-start-val', textObj.dataAnimateStartVal);
		}
		if(textObj.dataAnimateEndVal && textObj.dataAnimateEndVal != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-end-val', textObj.dataAnimateEndVal);
		}
		if(textObj.dataAnimateEase && textObj.dataAnimateEase != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-ease', textObj.dataAnimateEase);
		}
		if(textObj.dataAnimateDuration && textObj.dataAnimateDuration != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-duration', textObj.dataAnimateDuration);
		}
		if(textObj.dataAnimateDelay && textObj.dataAnimateDelay != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-delay', textObj.dataAnimateDelay);
		}
		if(textObj.dataAnimateRepeat && textObj.dataAnimateRepeat != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-repeat', textObj.dataAnimateRepeat);
		}
		if(textObj.dataAnimateYoyo && textObj.dataAnimateYoyo != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-yoyo', textObj.dataAnimateYoyo);
		}	
		if(textObj.dataAnimateReversed && textObj.dataAnimateReversed != ''){
			$(Selector.CONTAINER).find('.modal-alert').attr('data-animate-reversed', textObj.dataAnimateReversed);
		}		
	
		//--
	}
	function loadComplete(){
		APP.preloaderObj.hide();		
		
		//--for responsive
		$('body').addClass('modal-open');
		//--
		//--apply dynamic value attempt popup
		if(APP.configObj.assessment[APP.globalQuizObj.currentQuizId].isAvailable){
			$(Selector.CONTAINER).find('.current-attempt').html(APP.configObj.assessment[APP.globalQuizObj.currentQuizId].dataCurrentAttempt);
			$(Selector.CONTAINER).find('.total-attempts').html(APP.configObj.assessment[APP.globalQuizObj.currentQuizId].noOfAttempts);
		}		
		//--pause video and audio
			if(APP.vidPlayer){
				isVidPlaying = !(APP.vidPlayer.paused);
				isVidEnded = (APP.vidPlayer.ended);
				if(isVidPlaying && !isVidEnded){
					//video is playing so stop them
					APP.vidPlayer.pause();
				}
			}			
			if(APP.screenAudio){isAudPlaying = APP.screenAudio.playing() || false;}		
			
			if(isAudPlaying){APP.screenAudio.pause();}
			
		//--

		$(Selector.CONTAINER).show();		
		var alertObj = $(Selector.CONTAINER).find('.modal-alert');
		APP.globalMessageOpen = true;
		if(Selector.SHOW_ANIMATION){			
			var aniObj = APP.animationObj.generateAniObj($(alertObj));
			$(Selector.CONTAINER).find('.scroll-parent').scrollTop(0);
			aniObj.ON_COMPLETE = function(){
				
				updateModalPopLayout();
				
				Selector.isLoaded = true;
				//--for popup el animation 
				var aniEl = $(aniObj.EL).find('.pop-ani-el');
				if(aniEl.length){
					aniEl.each(function(inx){
						$(this).removeClass('visibility-hidden'); 
						var aniObj = APP.animationObj.generateAniObj($(this));
						aniObj.ON_COMPLETE = function(){
							
						}
						APP.animationObj.animate(aniObj);
					})
				}
				//--
			}
			APP.animationObj.animate(aniObj);
		}else{
			alertObj.show();			
			updateModalPopLayout();
			$(Selector.CONTAINER).find('.scroll-parent').scrollTop(0);
			Selector.isLoaded = true;
			//--for popup el animation
			var aniEl = $(alertObj).find('.pop-ani-el');
			if(aniEl.length){
				aniEl.each(function(inx){
					$(this).removeClass('visibility-hidden'); 
					var aniObj = APP.animationObj.generateAniObj($(this));
					aniObj.ON_COMPLETE = function(){
						
					}
					APP.animationObj.animate(aniObj);
				})
			}
			//--
		}
		
		addTemplateEvent();
	}
	function addTemplateEvent() {
		$(Selector.CONTAINER).find('.modal-btn').on('click', function(){
			if($(this).hasClass('yes-btn') || $(this).hasClass('ok-btn') || $(this).hasClass('continue-btn')){				
				processModal('true');
			}
			if($(this).hasClass('close-modal-btn') || $(this).hasClass('cancel-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){				
				processModal('false');
			}
			
		})
		//--for accordion minus icon
		$(Selector.CONTAINER).find('.tut-accordion-panel .panel-group').on('show.bs.collapse', function (e) {
			var curr = '#'+e.target.id;
			var btnObj = $(curr).siblings( ".accordion-btn-panel" )
			var id = parseInt(btnObj.data('id'));
			
			$(curr).siblings( ".accordion-btn-panel" ).find('.btn-icon').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);
			btnObj.addClass('visited current');			
			
		})
		//--for accordion plus icon
		$(Selector.CONTAINER).find('.tut-accordion-panel .panel-group').on('hide.bs.collapse', function (e) {			
			var curr = '#'+e.target.id;
			var btnObj = $(curr).siblings( ".accordion-btn-panel" )
			var id = parseInt(btnObj.data('id'));
			$(curr).siblings( ".accordion-btn-panel" ).find('.btn-icon').removeClass(Selector.FONT_ICON_CLASS_OBJ.minus).addClass(Selector.FONT_ICON_CLASS_OBJ.plus);
			btnObj.removeClass('current');
		})
		//--
		$(Selector.CONTAINER).off('click');
		if(Selector.ALLOW_BG_CLICK_CLOSE){
			$(Selector.CONTAINER).on('click', function(e){
				if($(this).attr('class') == $(e.target).attr('class')){
					if(Selector.isLoaded){
						processModal('false');
					}
				};
				
			});
		}
		
	}
	
	function processModal(_state){
		Selector.isLoaded = false;
		var alertObj = $(Selector.CONTAINER).find('.modal-alert');
		//--for responsive
		$('body').removeClass('modal-open');
		//--
		if(Selector.SHOW_ANIMATION){
			var aniObj = APP.animationObj.generateAniObj($(alertObj));
			aniObj.REVERSED = true;
			aniObj.ON_COMPLETE = function(){					
				APP.globalMessageOpen = false;
				if(APP.vidPlayer){
					if(isVidPlaying && !isVidEnded){
						//video is playing so play them again 
						APP.vidPlayer.play();					
					}
				}
				if(isAudPlaying){APP.screenAudio.play();}	
					
				$(Selector.CONTAINER).attr('class', 'global-modal-pop');
				$(Selector.CONTAINER).attr('style', '');
				$(Selector.CONTAINER).html('');
				$(Selector.CONTAINER).fadeOut('fast');		
				if(_state == 'true'){
					if(Selector.ON_OK){
						Selector.ON_OK();
					}
				}else{
					if(Selector.ON_CLOSE){
						Selector.ON_CLOSE();
					}
				}
				APP.globalModalObj = null;
				APP.commonFunObj.checkScreenSizePop();	
			}
			APP.animationObj.animate(aniObj);

		}else{
			$(Selector.CONTAINER).find('.modal-alert').hide();
			APP.globalMessageOpen = false;				
			$(Selector.CONTAINER).attr('class', 'global-modal-pop');
			$(Selector.CONTAINER).attr('style', '');
			$(Selector.CONTAINER).html('');
			$(Selector.CONTAINER).fadeOut('fast');
			if(APP.vidPlayer){
				if(isVidPlaying && !isVidEnded){
					//video is playing so play them again 
					APP.vidPlayer.play();
				}
			}
			if(isAudPlaying){APP.screenAudio.play();}	
			
			if(_state == 'true'){
				if(Selector.ON_OK){
					Selector.ON_OK();
				}
			}else{
				if(Selector.ON_CLOSE){
					Selector.ON_CLOSE();
				}
			}
			APP.globalModalObj = null;
			APP.commonFunObj.checkScreenSizePop();
		}	
		
	}
	function updateTemplateLayout() {	
		updateModalPopLayout();
	}
	function updateModalPopLayout(){
		if(APP.globalModalObj){
			var contHt = $(Selector.CONTAINER).height();
			var boxHt = $(Selector.CONTAINER).find('.modal-box').outerHeight(true);
						
			if((boxHt!=null && contHt!=null) && (boxHt > contHt)){
				$(Selector.CONTAINER).find('.modal-box').addClass('top');
			}else{
				$(Selector.CONTAINER).find('.modal-box').removeClass('top');
			}
			//--for help larger popup mobile
			if($('body').hasClass('responsive')){ 
				/* if(Selector.CLASS_NAME == 'help-pop'){
					$(Selector.CONTAINER).find('.modal-box').addClass('top');
				} */
			}
		}	
	}
	$(document).on(APP.eventObj.ON_CUSTOM_RESIZE, function (e) {
		updateTemplateLayout();
	});
}