function SideNavMenu() {
	var _this = this;
	var Selector = {};	
	var iconObj = Object.assign({}, APP.iconObj);
	var isVidPlaying = false;
	var isVidEnded = false;
	var isAudPlaying = false;
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_CONTAINER: '#sidenav_menu',
			XML_NODE: APP.globalXmlsObj.globalXML,
			FONT_ICON_CLASS_OBJ: {				
				plus: 'icon-plus',
				minus: 'icon-minus'
			},
			ON_INIT: null,
			ON_COMPLETE: null,
			ON_CLICK: null,
			isLoaded: false
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.hidePanel = function(){
		hidePanel();
	}
	function initTemplate() {
		APP.preloaderObj.show();
		if(Selector.XML_NODE == null){
			console.warn('XML NOT FOUND...')
			return;
		}
		
		Selector.isLoaded = false;
		APP.eventObj.sideNavMenuStatus(true);
		$(Selector.ACTIVITY_CONTAINER).html(getHtml());
		//--for responsive
		$('body').addClass('modal-open');
		//--
		createHeader();
		createContent();
		createFooter();
		addTemplateEvent();
		updateModButtonStatus();
		updateTopicButtonStatus();
		updateScreenButtonStatus();
		showPanel();
		APP.preloaderObj.hide();
	}
	function getHtml(){
		str ='';
		str += '<div class="side-panel">';
			/* str += '<div class="line-connector"></div>'; */
			str += '<div class="side-body">';
				str += '<div class="side-header">';				
				str += '</div>';
				str += '<div class="side-content">';
					str += '<div class="scrollable"></div>';				
				str += '</div>';
				str += '<div class="side-footer">';				
				str += '</div>';
			str += '</div>';
		str += '</div>';
		return str;
	}
	function createHeader(){
		var obj = $(Selector.ACTIVITY_CONTAINER).find('.side-header');
		var str ='';
		str +='<div class="display-table header-table">';
			str +='<div class="display-cell icon-cell icon-left left">';
				str += '<span class="font-icon icon-title-decoration-left "></span>';
			str += '</div>';
			str +='<div class="display-cell header-cell title-cell font-1 center">';
				str += '<span class="txt">'+Selector.XML_NODE.commonText[0].sideNavTitle[0].Text+'</span>';
			str += '</div>';
			str +='<div class="display-cell icon-cell icon-right right">';
				str += '<span class="font-icon icon-title-decoration-right "></span>';
			str += '</div>';
		str += '</div>';
		$(obj).html(str);
	}
	function createContent(){
		var obj = $(Selector.ACTIVITY_CONTAINER).find('.side-content .scrollable');
		var str ='';
		
		var menuXmlObj = Selector.XML_NODE.menu[0];
		for (var i=0; i<menuXmlObj.module.length; i++){
			if(i<=2){continue;}
			var curr = menuXmlObj.module[i];
			if(curr.hideOnMenu == 'true'){
				continue;
			}
			var statusClass="not-attempted"
			var modStatus = APP.courseDataObj.getModuleStatus(i);
			if(modStatus == '1'){
				statusClass = "incomplete"
			}
			if(modStatus == '2'){
				statusClass = "complete"
			}
			var mref = 'mod-'+i;
			var mtxt = curr.title[0].Text;
			var visibleClass = '';
			if(mtxt == null || mtxt == ''){
				visibleClass = 'no-title'
			}
			var className = curr.className || '';
			/* 1 */str += '<div id="'+mref+'" class="mod-btn-block '+mref+'  '+statusClass+' '+visibleClass+' '+className+'">';
					str+='<a class="btn transBg module-btn font-0" data-modid="'+i+'" href="javascript:void(0)">';
						str += '<div class="indicator indicator-cell display-cell v-center center"><span class="font-icon icon"></span></div>';	
						/* str+= '<span class ="btn-txt pre-txt display-cell v-top " >'+i+'. '+'</span>';				 */
						str+= '<span class ="btn-txt display-cell v-center " >'+mtxt+'</span>';						
					str += '</a>';
			/* 1 */str += '</div>';
			//create sub topic
			/* 1a */str += '<div id="collapse-'+mref+'" class="collapse collapse-mod collapse-'+mref+' ">';
			var subTopicXmlObj = curr.topic;
			for (var j=0; j<subTopicXmlObj.length; j++){
				var currSubTopic = subTopicXmlObj[j];
				if(currSubTopic.hideOnMenu == 'true'){
					continue;
				}
				var subTopicStatusClass="not-attempted"
				var subTopicStatus = APP.courseDataObj.getTopicStatus(i, j);
				if(subTopicStatus == '1'){
					subTopicStatusClass = "incomplete"
				}
				if(subTopicStatus == '2'){
					subTopicStatusClass = "complete"
				}
				var tref = 'topic-'+i+'_'+j;
				var ttxt = currSubTopic.title[0].Text;
				var tvisibleClass = '';
				if(ttxt == null || ttxt == ''){
					tvisibleClass = 'no-title'
				}
				/* 2 */str += '<div id="'+tref+'" class="topic-btn-block '+tref+' '+subTopicStatusClass+' '+tvisibleClass+'">';
						str+='<a class="btn transBg topic-btn font-2" data-modid="'+i+'" data-topicid="'+j+'" href="javascript:void(0)">';
							str += '<div class="indicator indicator-cell display-cell v-top center"><div class="icon-bg11"><span class="font-icon icon"></span></div></div>';
							str+= '<span class ="btn-txt pre-txt display-cell v-top " > - </span>';	
							str+= '<div class ="btn-txt display-cell v-top center" >'+ttxt+'</div>';
								
						str += '</a>';
				/* 2 */str += '</div>';
				//create screen
				/* 2a */str += '<div id="collapse-'+tref+'" class="collapse collapse-topic collapse-'+tref+' ">';
				var screenXmlObj = currSubTopic.screen;
				for (var k=0; k<screenXmlObj.length; k++){
					var currScreen = screenXmlObj[k];
					if(currScreen.hideOnMenu == 'true'){
						continue;
					}
					var screenStatusClass="not-attempted"
					var screenStatus = APP.courseDataObj.getScreenStatus({moduleId: i, topicId: j, screenId: k});
					if(screenStatus == '1'){
						screenStatusClass = "incomplete"
					}
					if(screenStatus == '2'){
						screenStatusClass = "complete"
					}
					var sref = 'screen-'+i+'_'+j+'_'+k;
					var stxt = currScreen.title[0].Text;
					var svisibleClass = '';
					if(stxt == null || stxt == ''){
						svisibleClass = 'no-title'
					}
					/* 3 */str += '<div id="'+sref+'" class="screen-btn-block '+sref+' '+screenStatusClass+' '+svisibleClass+'">';
							str+='<a class="btn transBg screen-btn" data-modid="'+i+'" data-topicid="'+j+'" data-screenid="'+k+'" href="javascript:void(0)">';
								str += '<div class="indicator indicator-cell display-cell v-center center"><div class="icon-bg11"><span class="font-icon icon"></span></div></div>';
								str+= '<div class ="btn-txt display-cell v-center center" >'+stxt+'</div>';
								/* str += '<span class="display-cell v-center btn-icon font-icon icon1 icon-triangle-right "></span>';	 */
							str += '</a>';
					/* 3 */str += '</div>';
				}
				/* 2a */str += '</div>';
				//screen end
			}
			/* 1a */str += '</div>';
			//topic end
		}
		//module end
		$(obj).html(str);
	}
	function createFooter(){
		var obj = $(Selector.ACTIVITY_CONTAINER).find('.side-footer');
		var str ='';
		str +='<div class="display-block center">';
			str +='<div class="display-inline-block ">';
				str += '<a class="btn transBg close-btn" href="javascript:void(0);" >';
					str += '<span class="btn-icon font-icon icon-cross display-cell v-center"></span>';
					str += '<span class="btn-txt display-cell v-center">'+Selector.XML_NODE.commonText[0].closeBtnText[0].Text+'</span>';
				str += '</a>';
			str += '</div>';
		str += '</div>';
		$(obj).html(str);
	}

	function addTemplateEvent() {
		$(Selector.ACTIVITY_CONTAINER).find('.module-btn').on('click', function(e){
			var parentBlock = $(this).parents('.mod-btn-block');
			if(parentBlock.hasClass('locked') || $(this).hasClass('disabled')){return false;};
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			var id = parentBlock.attr('id');
			var collapseObj = parentBlock.siblings('.collapse-'+id);
			//--if only 1 topic then direct load that screen
			var avlTopic = collapseObj.find('.topic-btn-block').length;
			if(avlTopic > 0){
				if(parentBlock.hasClass('open')){				
					collapseObj.find('.topic-btn-block').removeClass('open')
					collapseObj.find('.collapse-topic').slideUp('slow');
					collapseObj.slideUp('slow', function(){					
						
					});
					parentBlock.removeClass('open');
				}else{
					collapseObj.slideDown('slow', function(){
						//default open all topic
						//collapseObj.find('.collapse-topic').slideDown();
						//collapseObj.find('.topic-btn-block').addClass('open');
						//default open 1st topic
						//collapseObj.find('.collapse-topic').hide();
						//collapseObj.find('.collapse-topic').eq(0).slideDown();					
					});	
					parentBlock.addClass('open');			
				}
			}else{
				APP.navData.moduleId = $(this).data('modid');
				APP.navData.topicId = 0;
				APP.navData.screenId = 0;
				hidePanel(function (){
					APP.navigationObj.loadScreen();
				});
			}
			//--
			
		})
		$(Selector.ACTIVITY_CONTAINER).find('.topic-btn').on('click', function(e){
			var parentBlock = $(this).parents('.topic-btn-block');
			if(parentBlock.hasClass('locked') || $(this).hasClass('disabled')){return false;};	
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			var id = parentBlock.attr('id');
			var collapseObj = parentBlock.siblings('.collapse-'+id);
			//-- to check screen count
			var scrLen = collapseObj.find('.screen-btn').length;
			if(scrLen === 0){
				APP.navData.moduleId = $(this).data('modid');
				APP.navData.topicId = $(this).data('topicid');
				APP.navData.screenId = 0;
				hidePanel(function (){
					APP.navigationObj.loadScreen();
				});
			}else{
				if(parentBlock.hasClass('open')){
					collapseObj.slideUp('slow', function(){				
					});	
					parentBlock.removeClass('open');
				}else{
					collapseObj.slideDown('slow', function(){				
					});	
					parentBlock.addClass('open');	
				}
			}
			//--		
			
		})
		$(Selector.ACTIVITY_CONTAINER).find('.screen-btn').on('click', function(e){
			if($(this).parents('.screen-btn-block').hasClass('locked') || $(this).hasClass('disabled')){return false;};	
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			APP.navData.moduleId = $(this).data('modid');
			APP.navData.topicId = $(this).data('topicid');
			APP.navData.screenId = $(this).data('screenid');
			hidePanel(function (){
				APP.navigationObj.loadScreen();
			});
			
		})
		$(Selector.ACTIVITY_CONTAINER).find('.close-btn').on('click', function(e){
			if($(this).hasClass('disabled')){return false;};
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			if(Selector.isLoaded){
				hidePanel();
			}
		})
		$(Selector.ACTIVITY_CONTAINER).off('click');
		$(Selector.ACTIVITY_CONTAINER).on('click', function(e){	
			
			if($(this).attr('class') == $(e.target).attr('class')){
				if(Selector.isLoaded){
					hidePanel();
				}
			}
		});
	}

	function updateModButtonStatus(){	
		var cheatMode = APP.configObj.cheatMode;	
		var menuContainer = $(Selector.ACTIVITY_CONTAINER).find('.side-content');
		if(APP.configObj.menu.lockMenu == true && !cheatMode){
			menuContainer.find('.mod-btn-block.not-attempted').addClass('locked');
			menuContainer.find('.mod-btn-block').eq(0).removeClass('locked');
			//menuContainer.find('.mod-btn-block.complete').next().removeClass('locked');
			//custom for client
			if(menuContainer.find('.mod-btn-block').eq(0).hasClass('complete')){
				menuContainer.find('.mod-btn-block:not(.mod-lock)').removeClass('locked');			
			}
			var isMod3Complete = menuContainer.find('.mod-btn-block.mod-3').hasClass('complete');
			var isMod4Complete = menuContainer.find('.mod-btn-block.mod-4').hasClass('complete');
			var isMod5Complete = menuContainer.find('.mod-btn-block.mod-5').hasClass('complete');
			var isMod6Complete = menuContainer.find('.mod-btn-block.mod-6').hasClass('complete');
			var isSummaryComplete = menuContainer.find('.mod-btn-block.mod-summary').hasClass('complete');
			if(isMod3Complete && isMod4Complete && isMod5Complete && isMod6Complete){
				menuContainer.find('.mod-btn-block.mod-summary').removeClass('locked');
			}
			if(isSummaryComplete){
				menuContainer.find('.mod-btn-block.mod-certificate').removeClass('locked');
			}
		}
		//--indicator changes
		menuContainer.find('.mod-btn-block.locked').find('.indicator .icon').addClass(iconObj.locked);
		menuContainer.find('.mod-btn-block.not-attempted:not(.locked)').find('.indicator .icon').addClass(APP.iconObj.notAttempted);
		menuContainer.find('.mod-btn-block.incomplete').find('.indicator .icon').addClass(iconObj.incomplete);
		menuContainer.find('.mod-btn-block.complete').find('.indicator .icon').addClass(iconObj.complete);
	}
	function updateTopicButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find('.side-content');
		if(APP.configObj.menu.lockSubMenu == true && !cheatMode){
			subMenuContainer.find('.topic-btn-block.not-attempted').addClass('locked');
			subMenuContainer.find('.topic-btn-block').eq(0).removeClass('locked');			
			subMenuContainer.find('.topic-btn-block.complete').next().removeClass('locked');
		}
		
		//--indicator changes
		subMenuContainer.find('.topic-btn-block.locked').find('.indicator .icon').addClass(iconObj.locked);
		subMenuContainer.find('.topic-btn-block.not-attempted:not(.locked)').find('.indicator .icon').addClass(APP.iconObj.notAttempted);
		subMenuContainer.find('.topic-btn-block.incomplete').find('.indicator .icon').addClass(iconObj.incomplete);
		subMenuContainer.find('.topic-btn-block.complete').find('.indicator .icon').addClass(iconObj.complete);
		
	}
	function updateScreenButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find('.side-content');
		if(APP.configObj.menu.lockSubMenu == true && !cheatMode){
			subMenuContainer.find('.screen-btn-block.not-attempted').addClass('locked');
			subMenuContainer.find('.screen-btn-block').eq(0).removeClass('locked');			
			subMenuContainer.find('.screen-btn-block.complete').next().removeClass('locked');
		}
		
		//--indicator changes
		subMenuContainer.find('.screen-btn-block.locked').find('.indicator .icon').addClass(iconObj.locked);
		subMenuContainer.find('.screen-btn-block.not-attempted:not(.locked)').find('.indicator .icon').addClass(iconObj.notAttempted);
		subMenuContainer.find('.screen-btn-block.incomplete').find('.indicator .icon').addClass(iconObj.incomplete);
		subMenuContainer.find('.screen-btn-block.complete').find('.indicator .icon').addClass(iconObj.complete);
		
	}
	function showPanel(){	
		//--pause video and audio
		if(APP.vidPlayer){
			isVidPlaying = !(APP.vidPlayer.paused);
			isVidEnded = (APP.vidPlayer.ended);
			if(isVidPlaying && !isVidEnded){
				//video is playing so stop them
				APP.vidPlayer.pause();
			}
		}			
		if(APP.screenAudio){isAudPlaying = APP.screenAudio.playing() || false;}		
		
		if(isAudPlaying){APP.screenAudio.pause();}
		
		//--	
		//--default expand current screen row
		var currModObj = $(Selector.ACTIVITY_CONTAINER).find('#mod-'+APP.navData.moduleId);
		var currTopicObj = $(Selector.ACTIVITY_CONTAINER).find('#topic-'+APP.navData.moduleId+'_'+APP.navData.topicId);
		var currScreenObj = $(Selector.ACTIVITY_CONTAINER).find('#screen-'+APP.navData.moduleId+'_'+APP.navData.topicId+'_'+APP.navData.screenId);
		currModObj.addClass('current');
		currTopicObj.addClass('current');
		currScreenObj.addClass('current');
		var mid = currModObj.attr('id');
		var tid = currTopicObj.attr('id');
		
		var mcollapseObj = currModObj.siblings('.collapse-'+mid);
		currModObj.addClass('open');
		mcollapseObj.show();

		var tcollapseObj = currTopicObj.siblings('.collapse-'+tid);
		currTopicObj.addClass('open');
		tcollapseObj.show();
 
		/* //to open all
		$(Selector.ACTIVITY_CONTAINER).find('.mod-btn-block').addClass('open');
		$(Selector.ACTIVITY_CONTAINER).find('.collapse-mod').show();
		
		$(Selector.ACTIVITY_CONTAINER).fadeIn('slow'); */

		//---
		//---remove module and direct show topic if module length = 1
		var showModCount = APP.navigationObj.getActualModuleCount();
		if(showModCount <= 1){
			var firstMod = $(Selector.ACTIVITY_CONTAINER).find('.mod-btn-block').eq(0);			
			firstMod.addClass('current open').hide();
			var colObj = firstMod.siblings('.collapse-mod');
			colObj.show();
			colObj.find('.topic-btn-block').addClass('open');
			colObj.find('.collapse-topic').show();
		}
		$(Selector.ACTIVITY_CONTAINER).fadeIn('slow');
		//--slide main-div 		
		//$('#main-div').addClass('ani-slide');
		//custom edit for client remove side animation
		/* APP.animationObj.animate({
			EL: $('#main-div'),
			TYPE: 'margin-left',
			START_VAL: '-30%',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		}); */
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find('.side-panel'),
			TYPE: 'fade-in-bottom',
			START_VAL: '20px',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				Selector.isLoaded = true;
				$(this.target).focus();
			}
		});
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find('.line-connector'),
			TYPE: 'fade-in',
			DELAY: 0.5,
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		});
		
	}	
	function hidePanel(callback){	
		Selector.isLoaded = false;	
		APP.sideNavMenu = null;	
		//--for responsive
		$('body').removeClass('modal-open');
		//--	
		//$('#main-div').removeClass('ani-slide');
		//custom edit for client remove side animation
		/* APP.animationObj.animate({
			EL: $('#main-div'),
			TYPE: 'margin-left',
			START_VAL: '0%',
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		});	 */
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find('.line-connector'),
			TYPE: 'fade-out',
			START_VAL: '1',
			END_VAL: '0',
			DURATION: 0.0,
			ON_COMPLETE: function(){							
				
			}
		});
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find('.side-panel'),
			TYPE: 'fade-out-bottom',
			END_VAL: '20px',
			DELAY: 0.0,
			DURATION: 0.5,
			ON_COMPLETE: function(){							
				
			}
		});
		
		$(Selector.ACTIVITY_CONTAINER).fadeOut(500, function(){
			$(Selector.ACTIVITY_CONTAINER).hide().html('');
			APP.eventObj.sideNavMenuStatus(false);
			if(APP.vidPlayer){
				if(isVidPlaying && !isVidEnded){
					//video is playing so play them again 
					APP.vidPlayer.play();	
								
				}
			}
			if(isAudPlaying){APP.screenAudio.play();}
			if(callback){
				callback();
			}
		});	
	}
	function updateTemplateLayout() {}
	
	$(document).on(APP.eventObj.ON_CUSTOM_RESIZE, function (e) {
		updateTemplateLayout();
	});
}